<?php

namespace Treewec\Admin;

/**
 * Test class for FileAddForm.
 * Generated by PHPUnit on 2012-06-25 at 21:11:16.
 * @group admin_fileform
 */
class FileAddFormTest extends \PHPUnit_Framework_TestCase {

    private $formObject;    
    private $values;

    protected function setUp() {        
        mkdir(TEMP_FILEDIR . 'news');
        mkdir(TEMP_FILEDIR . 'news/existing');
        file_put_contents(TEMP_FILEDIR . 'news/existing.php', 'existing news');
        $this->values = array(
            'name' => 'filename', 
            'file_type' => \Treewec\FileSystem\FileType::FOLDER, 
            'file_template' => 'empty',
            'submit' => 'submit',
            'path' => TEMP_FILEDIR . 'news/'
        );
    }
    
    protected function tearDown() {
        $newsPath = TEMP_FILEDIR . 'news';
        $iterator = new \Treewec\DirectoryIterators\DirectoryIterator($newsPath);
        while($iterator->hasNext()) {
            $current = $iterator->next();
            if ($current->splFileInfo->getPathname() != $newsPath) {
                if ($current->splFileInfo->isDir()) {
                    $index = $current->splFileInfo->getPathname() . '/' . TREEWEC_NAME_OF_INDEX_FILE . TREEWEC_DEFAULT_FILE_EXTENSION;
                    if (file_exists($index)) {
                        // because index file is automatically created
                        unlink($index);
                    }
                    rmdir($current->splFileInfo->getPathname());
                } else {
                    unlink($current->splFileInfo->getPathname());
                }
            }
        }
        rmdir($newsPath);
    }

    public function testName() {
        $validValues = array('unique-valid-name');
        $this->assertValidAdd($validValues, 'name');

        $invalidValues = array(null, '', 'invalid characters : ? * hello');
        $this->assertInvalidAdd($invalidValues, 'name');
        // existing file
        $this->values['file_type'] = \Treewec\FileSystem\FileType::FILE;
        $invalidValues = array('existing');
        // existing folder
        $this->values['file_type'] = \Treewec\FileSystem\FileType::FOLDER;
        $invalidValues = array('existing');
    }

    public function testFileType() {        
        $validValues = array(\Treewec\FileSystem\FileType::FOLDER, \Treewec\FileSystem\FileType::FILE);
        $this->assertValidAdd($validValues, 'file_type');

        $invalidValues = array('hello', 'world', null);
        $this->assertInvalidAdd($invalidValues, 'file_type');
    }

    // TODO: function - returns content of the folder as array
    public function testFileTemplate() {        
        $fileTypes = array(
            \Treewec\FileSystem\FileType::FILE, \Treewec\FileSystem\FileType::FOLDER
        );
        foreach ($fileTypes as $fileType) {
            $this->values['file_type'] = $fileType;
            // template must be file from TREEWEC_DEFAULT_THEME/templates/ without TREEWEC_DEFAULT_FILE_EXTENSION
            $validValues = array('empty', 'news');
            $this->assertValidAdd($validValues, 'file_template');
            $invalidValues = array('hello', 'world', null);
            $this->assertInvalidAdd($invalidValues, 'file_template');
        }
    }
    
    public function testInvalidPath() {
        // it must be string (directory)
        $invalidValues = array(null, 'hello', TEMP_FILEDIR . 'existing.php', TEMP_FILEDIR . 'unexisting/');
        $this->assertInvalidAdd($invalidValues, 'path');
    }
    
    public function assertInvalidAdd($invalidValues, $arrayKey) {        
        foreach ($invalidValues as $value) {
            $this->values[$arrayKey] = $value;
            $this->setFormAndProcess();
            parent::assertFalse($this->formObject->isValid());
        }
    }
    
    public function assertValidAdd($values, $arrayKey) {        
        $fileCount = 0;
        foreach ($values as $value) {
            $this->values['name'] .= $fileCount++;
            $this->values[$arrayKey] = $value;
            $this->setFormAndProcess();
            parent::assertTrue($this->formObject->isValid());
        }
    }

    private function setFormAndProcess() {
        $this->formObject = new FileAddForm('submit', true);
        $this->formObject->setSuccessAction(FormSuccessAction::NOTHING);
        $_POST = $this->values;
        $_POST['order'] = 'no';
        $this->formObject->setFilePath($this->values['path']);
        $this->formObject->process();
    }

}

?>